(define-module (ui shapercontrol ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

(define (get-list . args)
  (form-update-enum "list" (apply woo-call "/shapercontrol/db_get_list"
                                             'start (form-value "start")
                                             'size (form-value "size")
                                             'find (form-value "find")
                                             args))
  (form-update-value-list '("start" "size" "range") (apply woo-call "/shapercontrol/db_get_ssr"
                                                                      'start (form-value "start")
                                                                      'size (form-value "size")
                                                                      'find (form-value "find")
                                                                      'language (form-value "language")
                                                                      args)))

(define (on-add)
  (woo-call "/shapercontrol/db_add" 'ip (form-value "add_ip")
                                    'rate (form-value "add_rate"))
  (form-update-value "add_ip" "")
  (form-update-value "add_rate" "")
  (get-list))

(define (on-search)
  (get-list 'start "0"))

(define (on-first)
  (get-list 'action "first"))

(define (on-back)
  (get-list 'action "back"))

(define (on-next)
  (get-list 'action "next"))

(define (on-last)
  (get-list 'action "last"))

(define (on-size)
  (get-list))

(define (on-del)
  (woo-call "/shapercontrol/db_del" 'list (form-value "list"))
  (get-list))

(define (ui-init)
  (form-update-visibility "check_label" (car (cdr (cdr (car (woo-call "/shapercontrol/check_config")))))) ; XXX
  (form-update-enum "size" (woo-call "/shapercontrol/db_avail_size" 'language (form-value "language")))
  (get-list))

(define (init)
  (ui-init)
  (form-bind "add_btn" "click" on-add)
  (form-bind "search_btn" "click" on-search)
  (form-bind "first_btn" "click" on-first)
  (form-bind "back_btn" "click" on-back)
  (form-bind "next_btn" "click" on-next)
  (form-bind "last_btn" "click" on-last)
  (form-bind "size" "change" on-size)
  (form-bind "del_btn" "click" on-del))
