(define-module (ui shapercontrol config ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (init))

(define (get-state)
  (catch/message
    (lambda()
      (form-update-value-list '("state") (woo-call "/shapercontrol/get_state")))))

(define (get-out-if-list)
  (form-update-enum "out_if" (woo-call "/shapercontrol/get_out_if_list"))
  (form-update-value-list '("out_if") (woo-call "/shapercontrol/get_out_if")))

(define (get-in-if-list)
  (form-update-enum "in_if" (woo-call "/shapercontrol/get_in_if_list"))
  (form-update-value-list '("in_if") (woo-call "/shapercontrol/get_in_if")))

(define (get-network-list)
  (form-update-enum "network" (woo-call "/shapercontrol/get_network_list")))

(define (get-bypass-int-list)
  (form-update-enum "bypass_int" (woo-call "/shapercontrol/get_bypass_int_list")))

(define (get-bypass-ext-list)
  (form-update-enum "bypass_ext" (woo-call "/shapercontrol/get_bypass_ext_list")))

(define (get-rate-ratio)
  (form-update-value-list '("rate_ratio") (woo-call "/shapercontrol/get_rate_ratio")))

(define (on-out-if)
  (let ((interface (form-value "out_if")))
    (if interface
      (begin
        (woo-call "/shapercontrol/set_out_if" 'interface interface)
        (get-state)
        (get-out-if-list)))))

(define (on-in-if)
  (let ((interface (form-value "in_if")))
    (if interface
      (begin
        (woo-call "/shapercontrol/set_in_if" 'interface interface)
        (get-state)
        (get-in-if-list)))))

(define (on-add-network)
  (let ((network (form-value "add_network")))
    (if network
      (begin
        (woo-call "/shapercontrol/add_network" 'network network)
        (get-network-list)
        (get-state)
        (form-update-value "add_network" "")))))

(define (on-add-bypass-int)
  (let ((network (form-value "add_bypass_int")))
    (if network
      (begin
        (woo-call "/shapercontrol/add_bypass_int" 'network network)
        (get-bypass-int-list)
        (get-state)
        (form-update-value "add_bypass_int" "")))))

(define (on-add-bypass-ext)
  (let ((network (form-value "add_bypass_ext")))
    (if network
      (begin
        (woo-call "/shapercontrol/add_bypass_ext" 'network network)
        (get-bypass-ext-list)
        (get-state)
        (form-update-value "add_bypass_ext" "")))))

(define (on-del-network)
  (let ((networks (form-value "network")))
    (if networks
      (begin
        (woo-call "/shapercontrol/del_network" 'networks networks)
        (get-state)
        (get-network-list)))))

(define (on-del-bypass-int)
  (let ((networks (form-value "bypass_int")))
    (if networks
      (begin
        (woo-call "/shapercontrol/del_bypass_int" 'networks networks)
        (get-state)
        (get-bypass-int-list)))))

(define (on-del-bypass-ext)
  (let ((networks (form-value "bypass_ext")))
    (if networks
      (begin
        (woo-call "/shapercontrol/del_bypass_ext" 'networks networks)
        (get-state)
        (get-bypass-ext-list)))))

(define (on-apply-state)
  (let ((state (form-value "state")))
    (woo-call "/shapercontrol/set_state" 'state state)
    (get-state)))

(define (on-apply-rate-ratio)
  (let ((rate_ratio (form-value "rate_ratio")))
    (if rate_ratio
      (begin
        (woo-call "/shapercontrol/set_rate_ratio" 'rate_ratio rate_ratio)
        (get-state)
        (get-rate-ratio)))))

(define (ui-init)
  (woo-call "/shapercontrol/init_config")
  (get-state)
  (get-out-if-list)
  (get-in-if-list)
  (get-network-list)
  (get-bypass-int-list)
  (get-bypass-ext-list)
  (get-rate-ratio))

(define (init)
  (ui-init)
  (form-bind "out_if" "change" on-out-if)
  (form-bind "in_if" "change" on-in-if)
  (form-bind "add_network_btn" "click" on-add-network)
  (form-bind "add_bypass_int_btn" "click" on-add-bypass-int)
  (form-bind "add_bypass_ext_btn" "click" on-add-bypass-ext)
  (form-bind "del_network_btn" "click" on-del-network)
  (form-bind "del_bypass_int_btn" "click" on-del-bypass-int)
  (form-bind "del_bypass_ext_btn" "click" on-del-bypass-ext)
  (form-bind "apply_state_btn" "click" on-apply-state)
  (form-bind "apply_rate_ratio_btn" "click" on-apply-rate-ratio))
